sdl2-2.5.5.1: Both high- and low-level bindings to the SDL library (version 2.0.6+).

Safe Haskell | Safe-Inferred
Language | Haskell2010

SDL.Raw.Types

Contents

- Type Aliases
  - Function Types
  - Common Types
- Data Structures

Synopsis

- type VkGetInstanceProcAddrFunc = VkInstance -> CString -> IO (FunPtr ())
- type AudioCallback = FunPtr (Ptr () -> Ptr Word8 -> CInt -> IO ())
- type EventFilter = FunPtr (Ptr () -> Ptr Event -> IO CInt)
- type HintCallback = FunPtr (Ptr () -> CString -> CString -> CString -> IO ())
- type LogOutputFunction = FunPtr (Ptr () -> CInt -> LogPriority -> CString -> IO ())
- type ThreadFunction = FunPtr (Ptr () -> IO CInt)
- type TimerCallback = FunPtr (Word32 -> Ptr () -> IO Word32)
- mkAudioCallback :: (Ptr () -> Ptr Word8 -> CInt -> IO ()) -> IO AudioCallback
- mkEventFilter :: (Ptr () -> Ptr Event -> IO CInt) -> IO EventFilter
- mkHintCallback :: (Ptr () -> CString -> CString -> CString -> IO ()) -> IO HintCallback
- mkLogOutputFunction :: (Ptr () -> CInt -> LogPriority -> CString -> IO ()) -> IO LogOutputFunction
- mkThreadFunction :: (Ptr () -> IO CInt) -> IO ThreadFunction
- mkTimerCallback :: (Word32 -> Ptr () -> IO Word32) -> IO TimerCallback
- type AudioDeviceID = Word32
- type AudioFormat = Word16
- type Cond = Ptr ()
- type Cursor = Ptr ()
- type FingerID = Int64
- type GameController = Ptr ()
- type GestureID = Int64
- type GLContext = Ptr ()
- type Haptic = Ptr ()
- type Joystick = Ptr ()
- type JoystickID = Int32
- type Mutex = Ptr ()
- type Renderer = Ptr ()
- type Sem = Ptr ()
- type SpinLock = CInt
- type SysWMinfo = Ptr ()
- type SysWMmsg = Ptr ()
- type Texture = Ptr ()
- type Thread = Ptr ()
- type ThreadID = CULong
- type TimerID = CInt
- type TLSID = CUInt
- type TouchID = Int64
- type VkInstance = Ptr ()
- type VkSurfaceKHR = Word64
- type Window = Ptr ()
- data Atomic = Atomic {
  - atomicValue :: !CInt
  }
- data AudioCVT = AudioCVT {
  - audioCVTNeeded :: !CInt
  - audioCVTSrcFormat :: !AudioFormat
  - audioCVTDstFormat :: !AudioFormat
  - audioCVTRateIncr :: !CDouble
  - audioCVTBuf :: !(Ptr Word8)
  - audioCVTLen :: !CInt
  - audioCVTLenCvt :: !CInt
  - audioCVTLenMult :: !CInt
  - audioCVTLenRatio :: !CDouble
  }
- data AudioSpec = AudioSpec {
  - audioSpecFreq :: !CInt
  - audioSpecFormat :: !AudioFormat
  - audioSpecChannels :: !Word8
  - audioSpecSilence :: !Word8
  - audioSpecSamples :: !Word16
  - audioSpecSize :: !Word32
  - audioSpecCallback :: !AudioCallback
  - audioSpecUserdata :: !(Ptr ())
  }
- data Color = Color {
  - colorR :: !Word8
  - colorG :: !Word8
  - colorB :: !Word8
  - colorA :: !Word8
  }
- data DisplayMode = DisplayMode {
  - displayModeFormat :: !Word32
  - displayModeW :: !CInt
  - displayModeH :: !CInt
  - displayModeRefreshRate :: !CInt
  - displayModeDriverData :: !(Ptr ())
  }
- data Event
  - = WindowEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - windowEventWindowID :: !Word32
    - windowEventEvent :: !Word8
    - windowEventData1 :: !Int32
    - windowEventData2 :: !Int32
    }
  - | KeyboardEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - keyboardEventWindowID :: !Word32
    - keyboardEventState :: !Word8
    - keyboardEventRepeat :: !Word8
    - keyboardEventKeysym :: !Keysym
    }
  - | TextEditingEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - textEditingEventWindowID :: !Word32
    - textEditingEventText :: ![CChar]
    - textEditingEventStart :: !Int32
    - textEditingEventLength :: !Int32
    }
  - | TextInputEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - textInputEventWindowID :: !Word32
    - textInputEventText :: ![CChar]
    }
  - | KeymapChangedEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    }
  - | MouseMotionEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - mouseMotionEventWindowID :: !Word32
    - mouseMotionEventWhich :: !Word32
    - mouseMotionEventState :: !Word32
    - mouseMotionEventX :: !Int32
    - mouseMotionEventY :: !Int32
    - mouseMotionEventXRel :: !Int32
    - mouseMotionEventYRel :: !Int32
    }
  - | MouseButtonEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - mouseButtonEventWindowID :: !Word32
    - mouseButtonEventWhich :: !Word32
    - mouseButtonEventButton :: !Word8
    - mouseButtonEventState :: !Word8
    - mouseButtonEventClicks :: !Word8
    - mouseButtonEventX :: !Int32
    - mouseButtonEventY :: !Int32
    }
  - | MouseWheelEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - mouseWheelEventWindowID :: !Word32
    - mouseWheelEventWhich :: !Word32
    - mouseWheelEventX :: !Int32
    - mouseWheelEventY :: !Int32
    - mouseWheelEventDirection :: !Word32
    }
  - | JoyAxisEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - joyAxisEventWhich :: !JoystickID
    - joyAxisEventAxis :: !Word8
    - joyAxisEventValue :: !Int16
    }
  - | JoyBallEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - joyBallEventWhich :: !JoystickID
    - joyBallEventBall :: !Word8
    - joyBallEventXRel :: !Int16
    - joyBallEventYRel :: !Int16
    }
  - | JoyHatEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - joyHatEventWhich :: !JoystickID
    - joyHatEventHat :: !Word8
    - joyHatEventValue :: !Word8
    }
  - | JoyButtonEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - joyButtonEventWhich :: !JoystickID
    - joyButtonEventButton :: !Word8
    - joyButtonEventState :: !Word8
    }
  - | JoyDeviceEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - joyDeviceEventWhich :: !Int32
    }
  - | ControllerAxisEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - controllerAxisEventWhich :: !JoystickID
    - controllerAxisEventAxis :: !Word8
    - controllerAxisEventValue :: !Int16
    }
  - | ControllerButtonEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - controllerButtonEventWhich :: !JoystickID
    - controllerButtonEventButton :: !Word8
    - controllerButtonEventState :: !Word8
    }
  - | ControllerDeviceEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - controllerDeviceEventWhich :: !Int32
    }
  - | AudioDeviceEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - audioDeviceEventWhich :: !Word32
    - audioDeviceEventIsCapture :: !Word8
    }
  - | QuitEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    }
  - | UserEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - userEventWindowID :: !Word32
    - userEventCode :: !Int32
    - userEventData1 :: !(Ptr ())
    - userEventData2 :: !(Ptr ())
    }
  - | SysWMEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - sysWMEventMsg :: !SysWMmsg
    }
  - | TouchFingerEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - touchFingerEventTouchID :: !TouchID
    - touchFingerEventFingerID :: !FingerID
    - touchFingerEventX :: !CFloat
    - touchFingerEventY :: !CFloat
    - touchFingerEventDX :: !CFloat
    - touchFingerEventDY :: !CFloat
    - touchFingerEventPressure :: !CFloat
    }
  - | MultiGestureEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - multiGestureEventTouchID :: !TouchID
    - multiGestureEventDTheta :: !CFloat
    - multiGestureEventDDist :: !CFloat
    - multiGestureEventX :: !CFloat
    - multiGestureEventY :: !CFloat
    - multiGestureEventNumFingers :: !Word16
    }
  - | DollarGestureEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - dollarGestureEventTouchID :: !TouchID
    - dollarGestureEventGestureID :: !GestureID
    - dollarGestureEventNumFingers :: !Word32
    - dollarGestureEventError :: !CFloat
    - dollarGestureEventX :: !CFloat
    - dollarGestureEventY :: !CFloat
    }
  - | DropEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    - dropEventFile :: !CString
    }
  - | ClipboardUpdateEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    }
  - | UnknownEvent {
    - eventType :: !Word32
    - eventTimestamp :: !Word32
    }
- data Finger = Finger {
  - fingerID :: !FingerID
  - fingerX :: !CFloat
  - fingerY :: !CFloat
  - fingerPressure :: !CFloat
  }
- data GameControllerButtonBind
  - = GameControllerButtonBindNone
  - | GameControllerButtonBindButton {
    - gameControllerButtonBindButton :: !CInt
    }
  - | GameControllerButtonBindAxis {
    - gameControllerButtonBindAxis :: !CInt
    }
  - | GameControllerButtonBindHat {
    - gameControllerButtonBindHat :: !CInt
    - gameControllerButtonBindHatMask :: !CInt
    }
- data HapticDirection = HapticDirection {
  - hapticDirectionType :: !Word8
  - hapticDirectionX :: !Int32
  - hapticDirectionY :: !Int32
  - hapticDirectionZ :: !Int32
  }
- data HapticEffect
  - = HapticConstant {
    - hapticEffectType :: !Word16
    - hapticConstantDirection :: !HapticDirection
    - hapticConstantLength :: !Word32
    - hapticConstantDelay :: !Word16
    - hapticConstantButton :: !Word16
    - hapticConstantInterval :: !Word16
    - hapticConstantLevel :: !Int16
    - hapticConstantAttackLength :: !Word16
    - hapticConstantAttackLevel :: !Word16
    - hapticConstantFadeLength :: !Word16
    - hapticConstantFadeLevel :: !Word16
    }
  - | HapticPeriodic {
    - hapticEffectType :: !Word16
    - hapticPeriodicDirection :: !HapticDirection
    - hapticPeriodicLength :: !Word32
    - hapticPeriodicDelay :: !Word16
    - hapticPeriodicButton :: !Word16
    - hapticPeriodicInterval :: !Word16
    - hapticPeriodicPeriod :: !Word16
    - hapticPeriodicMagnitude :: !Int16
    - hapticPeriodicOffset :: !Int16
    - hapticPeriodicPhase :: !Word16
    - hapticPeriodicAttackLength :: !Word16
    - hapticPeriodicAttackLevel :: !Word16
    - hapticPeriodicFadeLength :: !Word16
    - hapticPeriodicFadeLevel :: !Word16
    }
  - | HapticCondition {
    - hapticEffectType :: !Word16
    - hapticConditionLength :: !Word32
    - hapticConditionDelay :: !Word16
    - hapticConditionButton :: !Word16
    - hapticConditionInterval :: !Word16
    - hapticConditionRightSat :: ![Word16]
    - hapticConditionLeftSat :: ![Word16]
    - hapticConditionRightCoeff :: ![Int16]
    - hapticConditionLeftCoeff :: ![Int16]
    - hapticConditionDeadband :: ![Word16]
    - hapticConditionCenter :: ![Int16]
    }
  - | HapticRamp {
    - hapticEffectType :: !Word16
    - hapticRampDirection :: !HapticDirection
    - hapticRampLength :: !Word32
    - hapticRampDelay :: !Word16
    - hapticRampButton :: !Word16
    - hapticRampInterval :: !Word16
    - hapticRampStart :: !Int16
    - hapticRampEnd :: !Int16
    - hapticRampAttackLength :: !Word16
    - hapticRampAttackLevel :: !Word16
    - hapticRampFadeLength :: !Word16
    - hapticRampFadeLevel :: !Word16
    }
  - | HapticLeftRight {
    - hapticEffectType :: !Word16
    - hapticLeftRightLength :: !Word32
    - hapticLeftRightLargeMagnitude :: !Word16
    - hapticLeftRightSmallMagnitude :: !Word16
    }
  - | HapticCustom {
    - hapticEffectType :: !Word16
    - hapticCustomDirection :: !HapticDirection
    - hapticCustomLength :: !Word32
    - hapticCustomDelay :: !Word16
    - hapticCustomButton :: !Word16
    - hapticCustomInterval :: !Word16
    - hapticCustomChannels :: !Word8
    - hapticCustomPeriod :: !Word16
    - hapticCustomSamples :: !Word16
    - hapticCustomData :: !(Ptr Word16)
    - hapticCustomAttackLength :: !Word16
    - hapticCustomAttackLevel :: !Word16
    - hapticCustomFadeLength :: !Word16
    - hapticCustomFadeLevel :: !Word16
    }
- data JoystickGUID = JoystickGUID {
  - joystickGUID :: ![Word8]
  }
- data Keysym = Keysym {
  - keysymScancode :: !Scancode
  - keysymKeycode :: !Keycode
  - keysymMod :: !Word16
  }
- data MessageBoxButtonData = MessageBoxButtonData {
  - messageBoxButtonDataFlags :: !Word32
  - messageBoxButtonButtonID :: !CInt
  - messageBoxButtonText :: !CString
  }
- data MessageBoxColor = MessageBoxColor {
  - messageBoxColorR :: !Word8
  - messageBoxColorG :: !Word8
  - messageBoxColorB :: !Word8
  }
- data MessageBoxColorScheme = MessageBoxColorScheme {
  - messageBoxColorSchemeColorBackground :: !MessageBoxColor
  - messageBoxColorSchemeColorText :: !MessageBoxColor
  - messageBoxColorSchemeColorButtonBorder :: !MessageBoxColor
  - messageBoxColorSchemeColorButtonBackground :: !MessageBoxColor
  - messageBoxColorSchemeColorButtonSelected :: !MessageBoxColor
  }
- data MessageBoxData = MessageBoxData {
  - messageBoxDataFlags :: !Word32
  - messageBoxDataWindow :: !Window
  - messageBoxDataTitle :: !CString
  - messageBoxDataMessage :: !CString
  - messageBoxDataNumButtons :: !CInt
  - messageBoxDataButtons :: !(Ptr MessageBoxButtonData)
  - messageBoxDataColorScheme :: !(Ptr MessageBoxColorScheme)
  }
- data Palette = Palette {
  - paletteNColors :: !CInt
  - paletteColors :: !(Ptr Color)
  }
- data PixelFormat = PixelFormat {
  - pixelFormatFormat :: !Word32
  - pixelFormatPalette :: !(Ptr Palette)
  - pixelFormatBitsPerPixel :: !Word8
  - pixelFormatBytesPerPixel :: !Word8
  - pixelFormatRMask :: !Word32
  - pixelFormatGMask :: !Word32
  - pixelFormatBMask :: !Word32
  - pixelFormatAMask :: !Word32
  }
- data Point = Point {
  - pointX :: !CInt
  - pointY :: !CInt
  }
- data Rect = Rect {
  - rectX :: !CInt
  - rectY :: !CInt
  - rectW :: !CInt
  - rectH :: !CInt
  }
- data FPoint = FPoint {
  - fPointX :: !CFloat
  - fPointY :: !CFloat
  }
- data FRect = FRect {
  - fRectX :: !CFloat
  - fRectY :: !CFloat
  - fRectW :: !CFloat
  - fRectH :: !CFloat
  }
- data Vertex = Vertex {
  - vertexPosition :: !FPoint
  - vertexColor :: !Color
  - vertexTexCoord :: !FPoint
  }
- data RendererInfo = RendererInfo {
  - rendererInfoName :: !CString
  - rendererInfoFlags :: !Word32
  - rendererInfoNumTextureFormats :: !Word32
  - rendererInfoTextureFormats :: ![Word32]
  - rendererInfoMaxTextureWidth :: !CInt
  - rendererInfoMaxTextureHeight :: !CInt
  }
- data RWops = RWops {
  - rwopsSize :: !(FunPtr (Ptr RWops -> IO Int64))
  - rwopsSeek :: !(FunPtr (Ptr RWops -> Int64 -> CInt -> IO Int64))
  - rwopsRead :: !(FunPtr (Ptr RWops -> Ptr () -> CSize -> CSize -> IO CSize))
  - rwopsWrite :: !(FunPtr (Ptr RWops -> Ptr () -> CSize -> CSize -> IO CSize))
  - rwopsClose :: !(FunPtr (Ptr RWops -> IO CInt))
  - rwopsType :: !Word32
  }
- data Surface = Surface {
  - surfaceFormat :: !(Ptr PixelFormat)
  - surfaceW :: !CInt
  - surfaceH :: !CInt
  - surfacePixels :: !(Ptr ())
  - surfaceUserdata :: !(Ptr ())
  - surfaceClipRect :: !Rect
  - surfaceRefcount :: !CInt
  }
- data Version = Version {
  - versionMajor :: !Word8
  - versionMinor :: !Word8
  - versionPatch :: !Word8
  }

# Type Aliases

## Function Types

type VkGetInstanceProcAddrFunc = VkInstance -> CString -> IO (FunPtr ()) Source #

type AudioCallback = FunPtr (Ptr () -> Ptr Word8 -> CInt -> IO ()) Source #

type EventFilter = FunPtr (Ptr () -> Ptr Event -> IO CInt) Source #

type HintCallback = FunPtr (Ptr () -> CString -> CString -> CString -> IO ()) Source #

type LogOutputFunction = FunPtr (Ptr () -> CInt -> LogPriority -> CString -> IO ()) Source #

type ThreadFunction = FunPtr (Ptr () -> IO CInt) Source #

type TimerCallback = FunPtr (Word32 -> Ptr () -> IO Word32) Source #

mkAudioCallback :: (Ptr () -> Ptr Word8 -> CInt -> IO ()) -> IO AudioCallback Source #

The storage associated with the resulting `FunPtr` has to be released with `freeHaskellFunPtr` when it is no longer required.

mkEventFilter :: (Ptr () -> Ptr Event -> IO CInt) -> IO EventFilter Source #

The storage associated with the resulting `FunPtr` has to be released with `freeHaskellFunPtr` when it is no longer required.

mkHintCallback :: (Ptr () -> CString -> CString -> CString -> IO ()) -> IO HintCallback Source #

The storage associated with the resulting `FunPtr` has to be released with `freeHaskellFunPtr` when it is no longer required.

mkLogOutputFunction :: (Ptr () -> CInt -> LogPriority -> CString -> IO ()) -> IO LogOutputFunction Source #

The storage associated with the resulting `FunPtr` has to be released with `freeHaskellFunPtr` when it is no longer required.

mkThreadFunction :: (Ptr () -> IO CInt) -> IO ThreadFunction Source #

The storage associated with the resulting `FunPtr` has to be released with `freeHaskellFunPtr` when it is no longer required.

mkTimerCallback :: (Word32 -> Ptr () -> IO Word32) -> IO TimerCallback Source #

The storage associated with the resulting `FunPtr` has to be released with `freeHaskellFunPtr` when it is no longer required.

## Common Types

type AudioDeviceID = Word32 Source #

type AudioFormat = Word16 Source #

type Cond = Ptr () Source #

type Cursor = Ptr () Source #

type FingerID = Int64 Source #

type GameController = Ptr () Source #

type GestureID = Int64 Source #

type GLContext = Ptr () Source #

type Haptic = Ptr () Source #

type Joystick = Ptr () Source #

type JoystickID = Int32 Source #

type Mutex = Ptr () Source #

type Renderer = Ptr () Source #

type Sem = Ptr () Source #

type SpinLock = CInt Source #

type SysWMinfo = Ptr () Source #

type SysWMmsg = Ptr () Source #

type Texture = Ptr () Source #

type Thread = Ptr () Source #

type ThreadID = CULong Source #

type TimerID = CInt Source #

type TLSID = CUInt Source #

type TouchID = Int64 Source #

type VkInstance = Ptr () Source #

type VkSurfaceKHR = Word64 Source #

type Window = Ptr () Source #

# Data Structures

data Atomic Source #

Constructors

Atomic |

Fields

- atomicValue :: !CInt

#### Instances

Instances details

Storable Atomic Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Atomic -> Int Source #

alignment :: Atomic -> Int Source #

peekElemOff :: Ptr Atomic -> Int -> IO Atomic Source #

pokeElemOff :: Ptr Atomic -> Int -> Atomic -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Atomic Source #

pokeByteOff :: Ptr b -> Int -> Atomic -> IO () Source #

peek :: Ptr Atomic -> IO Atomic Source #

poke :: Ptr Atomic -> Atomic -> IO () Source #

Show Atomic Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Atomic -> ShowS Source # show :: Atomic -> String Source # showList :: [Atomic] -> ShowS Source #
Eq Atomic Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Atomic -> Atomic -> Bool Source # (/=) :: Atomic -> Atomic -> Bool Source #

data AudioCVT Source #

Constructors

AudioCVT |

Fields

- audioCVTNeeded :: !CInt
- audioCVTSrcFormat :: !AudioFormat
- audioCVTDstFormat :: !AudioFormat
- audioCVTRateIncr :: !CDouble
- audioCVTBuf :: !(Ptr Word8)
- audioCVTLen :: !CInt
- audioCVTLenCvt :: !CInt
- audioCVTLenMult :: !CInt
- audioCVTLenRatio :: !CDouble

#### Instances

Instances details

Storable AudioCVT Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: AudioCVT -> Int Source #

alignment :: AudioCVT -> Int Source #

peekElemOff :: Ptr AudioCVT -> Int -> IO AudioCVT Source #

pokeElemOff :: Ptr AudioCVT -> Int -> AudioCVT -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO AudioCVT Source #

pokeByteOff :: Ptr b -> Int -> AudioCVT -> IO () Source #

peek :: Ptr AudioCVT -> IO AudioCVT Source #

poke :: Ptr AudioCVT -> AudioCVT -> IO () Source #

Show AudioCVT Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> AudioCVT -> ShowS Source # show :: AudioCVT -> String Source # showList :: [AudioCVT] -> ShowS Source #
Eq AudioCVT Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: AudioCVT -> AudioCVT -> Bool Source # (/=) :: AudioCVT -> AudioCVT -> Bool Source #

data AudioSpec Source #

Constructors

AudioSpec |

Fields

- audioSpecFreq :: !CInt
- audioSpecFormat :: !AudioFormat
- audioSpecChannels :: !Word8
- audioSpecSilence :: !Word8
- audioSpecSamples :: !Word16
- audioSpecSize :: !Word32
- audioSpecCallback :: !AudioCallback
- audioSpecUserdata :: !(Ptr ())

#### Instances

Instances details

Storable AudioSpec Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: AudioSpec -> Int Source #

alignment :: AudioSpec -> Int Source #

peekElemOff :: Ptr AudioSpec -> Int -> IO AudioSpec Source #

pokeElemOff :: Ptr AudioSpec -> Int -> AudioSpec -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO AudioSpec Source #

pokeByteOff :: Ptr b -> Int -> AudioSpec -> IO () Source #

peek :: Ptr AudioSpec -> IO AudioSpec Source #

poke :: Ptr AudioSpec -> AudioSpec -> IO () Source #

Show AudioSpec Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> AudioSpec -> ShowS Source # show :: AudioSpec -> String Source # showList :: [AudioSpec] -> ShowS Source #
Eq AudioSpec Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: AudioSpec -> AudioSpec -> Bool Source # (/=) :: AudioSpec -> AudioSpec -> Bool Source #

data Color Source #

Constructors

Color |

Fields

- colorR :: !Word8
- colorG :: !Word8
- colorB :: !Word8
- colorA :: !Word8

#### Instances

Instances details

Storable Color Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Color -> Int Source #

alignment :: Color -> Int Source #

peekElemOff :: Ptr Color -> Int -> IO Color Source #

pokeElemOff :: Ptr Color -> Int -> Color -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Color Source #

pokeByteOff :: Ptr b -> Int -> Color -> IO () Source #

peek :: Ptr Color -> IO Color Source #

poke :: Ptr Color -> Color -> IO () Source #

Show Color Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Color -> ShowS Source # show :: Color -> String Source # showList :: [Color] -> ShowS Source #
Eq Color Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Color -> Color -> Bool Source # (/=) :: Color -> Color -> Bool Source #

data DisplayMode Source #

Constructors

DisplayMode |

Fields

- displayModeFormat :: !Word32
- displayModeW :: !CInt
- displayModeH :: !CInt
- displayModeRefreshRate :: !CInt
- displayModeDriverData :: !(Ptr ())

#### Instances

Instances details

Storable DisplayMode Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: DisplayMode -> Int Source #

alignment :: DisplayMode -> Int Source #

peekElemOff :: Ptr DisplayMode -> Int -> IO DisplayMode Source #

pokeElemOff :: Ptr DisplayMode -> Int -> DisplayMode -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO DisplayMode Source #

pokeByteOff :: Ptr b -> Int -> DisplayMode -> IO () Source #

peek :: Ptr DisplayMode -> IO DisplayMode Source #

poke :: Ptr DisplayMode -> DisplayMode -> IO () Source #

Show DisplayMode Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> DisplayMode -> ShowS Source # show :: DisplayMode -> String Source # showList :: [DisplayMode] -> ShowS Source #
Eq DisplayMode Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: DisplayMode -> DisplayMode -> Bool Source # (/=) :: DisplayMode -> DisplayMode -> Bool Source #

data Event Source #

Constructors

WindowEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- windowEventWindowID :: !Word32
- windowEventEvent :: !Word8
- windowEventData1 :: !Int32
- windowEventData2 :: !Int32

KeyboardEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- keyboardEventWindowID :: !Word32
- keyboardEventState :: !Word8
- keyboardEventRepeat :: !Word8
- keyboardEventKeysym :: !Keysym

TextEditingEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- textEditingEventWindowID :: !Word32
- textEditingEventText :: ![CChar]
- textEditingEventStart :: !Int32
- textEditingEventLength :: !Int32

TextInputEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- textInputEventWindowID :: !Word32
- textInputEventText :: ![CChar]

KeymapChangedEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32

MouseMotionEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- mouseMotionEventWindowID :: !Word32
- mouseMotionEventWhich :: !Word32
- mouseMotionEventState :: !Word32
- mouseMotionEventX :: !Int32
- mouseMotionEventY :: !Int32
- mouseMotionEventXRel :: !Int32
- mouseMotionEventYRel :: !Int32

MouseButtonEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- mouseButtonEventWindowID :: !Word32
- mouseButtonEventWhich :: !Word32
- mouseButtonEventButton :: !Word8
- mouseButtonEventState :: !Word8
- mouseButtonEventClicks :: !Word8
- mouseButtonEventX :: !Int32
- mouseButtonEventY :: !Int32

MouseWheelEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- mouseWheelEventWindowID :: !Word32
- mouseWheelEventWhich :: !Word32
- mouseWheelEventX :: !Int32
- mouseWheelEventY :: !Int32
- mouseWheelEventDirection :: !Word32

JoyAxisEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- joyAxisEventWhich :: !JoystickID
- joyAxisEventAxis :: !Word8
- joyAxisEventValue :: !Int16

JoyBallEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- joyBallEventWhich :: !JoystickID
- joyBallEventBall :: !Word8
- joyBallEventXRel :: !Int16
- joyBallEventYRel :: !Int16

JoyHatEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- joyHatEventWhich :: !JoystickID
- joyHatEventHat :: !Word8
- joyHatEventValue :: !Word8

JoyButtonEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- joyButtonEventWhich :: !JoystickID
- joyButtonEventButton :: !Word8
- joyButtonEventState :: !Word8

JoyDeviceEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- joyDeviceEventWhich :: !Int32

ControllerAxisEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- controllerAxisEventWhich :: !JoystickID
- controllerAxisEventAxis :: !Word8
- controllerAxisEventValue :: !Int16

ControllerButtonEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- controllerButtonEventWhich :: !JoystickID
- controllerButtonEventButton :: !Word8
- controllerButtonEventState :: !Word8

ControllerDeviceEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- controllerDeviceEventWhich :: !Int32

AudioDeviceEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- audioDeviceEventWhich :: !Word32
- audioDeviceEventIsCapture :: !Word8

QuitEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32

UserEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- userEventWindowID :: !Word32
- userEventCode :: !Int32
- userEventData1 :: !(Ptr ())
- userEventData2 :: !(Ptr ())

SysWMEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- sysWMEventMsg :: !SysWMmsg

TouchFingerEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- touchFingerEventTouchID :: !TouchID
- touchFingerEventFingerID :: !FingerID
- touchFingerEventX :: !CFloat
- touchFingerEventY :: !CFloat
- touchFingerEventDX :: !CFloat
- touchFingerEventDY :: !CFloat
- touchFingerEventPressure :: !CFloat

MultiGestureEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- multiGestureEventTouchID :: !TouchID
- multiGestureEventDTheta :: !CFloat
- multiGestureEventDDist :: !CFloat
- multiGestureEventX :: !CFloat
- multiGestureEventY :: !CFloat
- multiGestureEventNumFingers :: !Word16

DollarGestureEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- dollarGestureEventTouchID :: !TouchID
- dollarGestureEventGestureID :: !GestureID
- dollarGestureEventNumFingers :: !Word32
- dollarGestureEventError :: !CFloat
- dollarGestureEventX :: !CFloat
- dollarGestureEventY :: !CFloat

DropEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32
- dropEventFile :: !CString

ClipboardUpdateEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32

UnknownEvent |

Fields

- eventType :: !Word32
- eventTimestamp :: !Word32

#### Instances

Instances details

Storable Event Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Event -> Int Source #

alignment :: Event -> Int Source #

peekElemOff :: Ptr Event -> Int -> IO Event Source #

pokeElemOff :: Ptr Event -> Int -> Event -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Event Source #

pokeByteOff :: Ptr b -> Int -> Event -> IO () Source #

peek :: Ptr Event -> IO Event Source #

poke :: Ptr Event -> Event -> IO () Source #

Show Event Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Event -> ShowS Source # show :: Event -> String Source # showList :: [Event] -> ShowS Source #
Eq Event Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Event -> Event -> Bool Source # (/=) :: Event -> Event -> Bool Source #

data Finger Source #

Constructors

Finger |

Fields

- fingerID :: !FingerID
- fingerX :: !CFloat
- fingerY :: !CFloat
- fingerPressure :: !CFloat

#### Instances

Instances details

Storable Finger Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Finger -> Int Source #

alignment :: Finger -> Int Source #

peekElemOff :: Ptr Finger -> Int -> IO Finger Source #

pokeElemOff :: Ptr Finger -> Int -> Finger -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Finger Source #

pokeByteOff :: Ptr b -> Int -> Finger -> IO () Source #

peek :: Ptr Finger -> IO Finger Source #

poke :: Ptr Finger -> Finger -> IO () Source #

Show Finger Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Finger -> ShowS Source # show :: Finger -> String Source # showList :: [Finger] -> ShowS Source #
Eq Finger Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Finger -> Finger -> Bool Source # (/=) :: Finger -> Finger -> Bool Source #

data GameControllerButtonBind Source #

Constructors

GameControllerButtonBindNone |
GameControllerButtonBindButton |

Fields

- gameControllerButtonBindButton :: !CInt

GameControllerButtonBindAxis |

Fields

- gameControllerButtonBindAxis :: !CInt

GameControllerButtonBindHat |

Fields

- gameControllerButtonBindHat :: !CInt
- gameControllerButtonBindHatMask :: !CInt

#### Instances

Instances details

Storable GameControllerButtonBind Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: GameControllerButtonBind -> Int Source #

alignment :: GameControllerButtonBind -> Int Source #

peekElemOff :: Ptr GameControllerButtonBind -> Int -> IO GameControllerButtonBind Source #

pokeElemOff :: Ptr GameControllerButtonBind -> Int -> GameControllerButtonBind -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO GameControllerButtonBind Source #

pokeByteOff :: Ptr b -> Int -> GameControllerButtonBind -> IO () Source #

peek :: Ptr GameControllerButtonBind -> IO GameControllerButtonBind Source #

poke :: Ptr GameControllerButtonBind -> GameControllerButtonBind -> IO () Source #

Show GameControllerButtonBind Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> GameControllerButtonBind -> ShowS Source # show :: GameControllerButtonBind -> String Source # showList :: [GameControllerButtonBind] -> ShowS Source #
Eq GameControllerButtonBind Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: GameControllerButtonBind -> GameControllerButtonBind -> Bool Source # (/=) :: GameControllerButtonBind -> GameControllerButtonBind -> Bool Source #

data HapticDirection Source #

Constructors

HapticDirection |

Fields

- hapticDirectionType :: !Word8
- hapticDirectionX :: !Int32
- hapticDirectionY :: !Int32
- hapticDirectionZ :: !Int32

#### Instances

Instances details

Storable HapticDirection Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: HapticDirection -> Int Source #

alignment :: HapticDirection -> Int Source #

peekElemOff :: Ptr HapticDirection -> Int -> IO HapticDirection Source #

pokeElemOff :: Ptr HapticDirection -> Int -> HapticDirection -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO HapticDirection Source #

pokeByteOff :: Ptr b -> Int -> HapticDirection -> IO () Source #

peek :: Ptr HapticDirection -> IO HapticDirection Source #

poke :: Ptr HapticDirection -> HapticDirection -> IO () Source #

Show HapticDirection Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> HapticDirection -> ShowS Source # show :: HapticDirection -> String Source # showList :: [HapticDirection] -> ShowS Source #
Eq HapticDirection Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: HapticDirection -> HapticDirection -> Bool Source # (/=) :: HapticDirection -> HapticDirection -> Bool Source #

data HapticEffect Source #

Constructors

HapticConstant |

Fields

- hapticEffectType :: !Word16
- hapticConstantDirection :: !HapticDirection
- hapticConstantLength :: !Word32
- hapticConstantDelay :: !Word16
- hapticConstantButton :: !Word16
- hapticConstantInterval :: !Word16
- hapticConstantLevel :: !Int16
- hapticConstantAttackLength :: !Word16
- hapticConstantAttackLevel :: !Word16
- hapticConstantFadeLength :: !Word16
- hapticConstantFadeLevel :: !Word16

HapticPeriodic |

Fields

- hapticEffectType :: !Word16
- hapticPeriodicDirection :: !HapticDirection
- hapticPeriodicLength :: !Word32
- hapticPeriodicDelay :: !Word16
- hapticPeriodicButton :: !Word16
- hapticPeriodicInterval :: !Word16
- hapticPeriodicPeriod :: !Word16
- hapticPeriodicMagnitude :: !Int16
- hapticPeriodicOffset :: !Int16
- hapticPeriodicPhase :: !Word16
- hapticPeriodicAttackLength :: !Word16
- hapticPeriodicAttackLevel :: !Word16
- hapticPeriodicFadeLength :: !Word16
- hapticPeriodicFadeLevel :: !Word16

HapticCondition |

Fields

- hapticEffectType :: !Word16
- hapticConditionLength :: !Word32
- hapticConditionDelay :: !Word16
- hapticConditionButton :: !Word16
- hapticConditionInterval :: !Word16
- hapticConditionRightSat :: ![Word16]
- hapticConditionLeftSat :: ![Word16]
- hapticConditionRightCoeff :: ![Int16]
- hapticConditionLeftCoeff :: ![Int16]
- hapticConditionDeadband :: ![Word16]
- hapticConditionCenter :: ![Int16]

HapticRamp |

Fields

- hapticEffectType :: !Word16
- hapticRampDirection :: !HapticDirection
- hapticRampLength :: !Word32
- hapticRampDelay :: !Word16
- hapticRampButton :: !Word16
- hapticRampInterval :: !Word16
- hapticRampStart :: !Int16
- hapticRampEnd :: !Int16
- hapticRampAttackLength :: !Word16
- hapticRampAttackLevel :: !Word16
- hapticRampFadeLength :: !Word16
- hapticRampFadeLevel :: !Word16

HapticLeftRight |

Fields

- hapticEffectType :: !Word16
- hapticLeftRightLength :: !Word32
- hapticLeftRightLargeMagnitude :: !Word16
- hapticLeftRightSmallMagnitude :: !Word16

HapticCustom |

Fields

- hapticEffectType :: !Word16
- hapticCustomDirection :: !HapticDirection
- hapticCustomLength :: !Word32
- hapticCustomDelay :: !Word16
- hapticCustomButton :: !Word16
- hapticCustomInterval :: !Word16
- hapticCustomChannels :: !Word8
- hapticCustomPeriod :: !Word16
- hapticCustomSamples :: !Word16
- hapticCustomData :: !(Ptr Word16)
- hapticCustomAttackLength :: !Word16
- hapticCustomAttackLevel :: !Word16
- hapticCustomFadeLength :: !Word16
- hapticCustomFadeLevel :: !Word16

#### Instances

Instances details

Storable HapticEffect Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: HapticEffect -> Int Source #

alignment :: HapticEffect -> Int Source #

peekElemOff :: Ptr HapticEffect -> Int -> IO HapticEffect Source #

pokeElemOff :: Ptr HapticEffect -> Int -> HapticEffect -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO HapticEffect Source #

pokeByteOff :: Ptr b -> Int -> HapticEffect -> IO () Source #

peek :: Ptr HapticEffect -> IO HapticEffect Source #

poke :: Ptr HapticEffect -> HapticEffect -> IO () Source #

Show HapticEffect Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> HapticEffect -> ShowS Source # show :: HapticEffect -> String Source # showList :: [HapticEffect] -> ShowS Source #
Eq HapticEffect Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: HapticEffect -> HapticEffect -> Bool Source # (/=) :: HapticEffect -> HapticEffect -> Bool Source #

data JoystickGUID Source #

Constructors

JoystickGUID |

Fields

- joystickGUID :: ![Word8]

#### Instances

Instances details

Storable JoystickGUID Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: JoystickGUID -> Int Source #

alignment :: JoystickGUID -> Int Source #

peekElemOff :: Ptr JoystickGUID -> Int -> IO JoystickGUID Source #

pokeElemOff :: Ptr JoystickGUID -> Int -> JoystickGUID -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO JoystickGUID Source #

pokeByteOff :: Ptr b -> Int -> JoystickGUID -> IO () Source #

peek :: Ptr JoystickGUID -> IO JoystickGUID Source #

poke :: Ptr JoystickGUID -> JoystickGUID -> IO () Source #

Show JoystickGUID Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> JoystickGUID -> ShowS Source # show :: JoystickGUID -> String Source # showList :: [JoystickGUID] -> ShowS Source #
Eq JoystickGUID Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: JoystickGUID -> JoystickGUID -> Bool Source # (/=) :: JoystickGUID -> JoystickGUID -> Bool Source #

data Keysym Source #

Constructors

Keysym |

Fields

- keysymScancode :: !Scancode
- keysymKeycode :: !Keycode
- keysymMod :: !Word16

#### Instances

Instances details

Storable Keysym Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Keysym -> Int Source #

alignment :: Keysym -> Int Source #

peekElemOff :: Ptr Keysym -> Int -> IO Keysym Source #

pokeElemOff :: Ptr Keysym -> Int -> Keysym -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Keysym Source #

pokeByteOff :: Ptr b -> Int -> Keysym -> IO () Source #

peek :: Ptr Keysym -> IO Keysym Source #

poke :: Ptr Keysym -> Keysym -> IO () Source #

Show Keysym Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Keysym -> ShowS Source # show :: Keysym -> String Source # showList :: [Keysym] -> ShowS Source #
Eq Keysym Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Keysym -> Keysym -> Bool Source # (/=) :: Keysym -> Keysym -> Bool Source #

data MessageBoxButtonData Source #

Constructors

MessageBoxButtonData |

Fields

- messageBoxButtonDataFlags :: !Word32
- messageBoxButtonButtonID :: !CInt
- messageBoxButtonText :: !CString

#### Instances

Instances details

Storable MessageBoxButtonData Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: MessageBoxButtonData -> Int Source #

alignment :: MessageBoxButtonData -> Int Source #

peekElemOff :: Ptr MessageBoxButtonData -> Int -> IO MessageBoxButtonData Source #

pokeElemOff :: Ptr MessageBoxButtonData -> Int -> MessageBoxButtonData -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MessageBoxButtonData Source #

pokeByteOff :: Ptr b -> Int -> MessageBoxButtonData -> IO () Source #

peek :: Ptr MessageBoxButtonData -> IO MessageBoxButtonData Source #

poke :: Ptr MessageBoxButtonData -> MessageBoxButtonData -> IO () Source #

Show MessageBoxButtonData Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> MessageBoxButtonData -> ShowS Source # show :: MessageBoxButtonData -> String Source # showList :: [MessageBoxButtonData] -> ShowS Source #
Eq MessageBoxButtonData Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: MessageBoxButtonData -> MessageBoxButtonData -> Bool Source # (/=) :: MessageBoxButtonData -> MessageBoxButtonData -> Bool Source #

data MessageBoxColor Source #

Constructors

MessageBoxColor |

Fields

- messageBoxColorR :: !Word8
- messageBoxColorG :: !Word8
- messageBoxColorB :: !Word8

#### Instances

Instances details

Storable MessageBoxColor Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: MessageBoxColor -> Int Source #

alignment :: MessageBoxColor -> Int Source #

peekElemOff :: Ptr MessageBoxColor -> Int -> IO MessageBoxColor Source #

pokeElemOff :: Ptr MessageBoxColor -> Int -> MessageBoxColor -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MessageBoxColor Source #

pokeByteOff :: Ptr b -> Int -> MessageBoxColor -> IO () Source #

peek :: Ptr MessageBoxColor -> IO MessageBoxColor Source #

poke :: Ptr MessageBoxColor -> MessageBoxColor -> IO () Source #

Show MessageBoxColor Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> MessageBoxColor -> ShowS Source # show :: MessageBoxColor -> String Source # showList :: [MessageBoxColor] -> ShowS Source #
Eq MessageBoxColor Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: MessageBoxColor -> MessageBoxColor -> Bool Source # (/=) :: MessageBoxColor -> MessageBoxColor -> Bool Source #

data MessageBoxColorScheme Source #

Constructors

MessageBoxColorScheme |

Fields

- messageBoxColorSchemeColorBackground :: !MessageBoxColor
- messageBoxColorSchemeColorText :: !MessageBoxColor
- messageBoxColorSchemeColorButtonBorder :: !MessageBoxColor
- messageBoxColorSchemeColorButtonBackground :: !MessageBoxColor
- messageBoxColorSchemeColorButtonSelected :: !MessageBoxColor

#### Instances

Instances details

Storable MessageBoxColorScheme Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: MessageBoxColorScheme -> Int Source #

alignment :: MessageBoxColorScheme -> Int Source #

peekElemOff :: Ptr MessageBoxColorScheme -> Int -> IO MessageBoxColorScheme Source #

pokeElemOff :: Ptr MessageBoxColorScheme -> Int -> MessageBoxColorScheme -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MessageBoxColorScheme Source #

pokeByteOff :: Ptr b -> Int -> MessageBoxColorScheme -> IO () Source #

peek :: Ptr MessageBoxColorScheme -> IO MessageBoxColorScheme Source #

poke :: Ptr MessageBoxColorScheme -> MessageBoxColorScheme -> IO () Source #

Show MessageBoxColorScheme Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> MessageBoxColorScheme -> ShowS Source # show :: MessageBoxColorScheme -> String Source # showList :: [MessageBoxColorScheme] -> ShowS Source #
Eq MessageBoxColorScheme Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: MessageBoxColorScheme -> MessageBoxColorScheme -> Bool Source # (/=) :: MessageBoxColorScheme -> MessageBoxColorScheme -> Bool Source #

data MessageBoxData Source #

Constructors

MessageBoxData |

Fields

- messageBoxDataFlags :: !Word32
- messageBoxDataWindow :: !Window
- messageBoxDataTitle :: !CString
- messageBoxDataMessage :: !CString
- messageBoxDataNumButtons :: !CInt
- messageBoxDataButtons :: !(Ptr MessageBoxButtonData)
- messageBoxDataColorScheme :: !(Ptr MessageBoxColorScheme)

#### Instances

Instances details

Storable MessageBoxData Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: MessageBoxData -> Int Source #

alignment :: MessageBoxData -> Int Source #

peekElemOff :: Ptr MessageBoxData -> Int -> IO MessageBoxData Source #

pokeElemOff :: Ptr MessageBoxData -> Int -> MessageBoxData -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO MessageBoxData Source #

pokeByteOff :: Ptr b -> Int -> MessageBoxData -> IO () Source #

peek :: Ptr MessageBoxData -> IO MessageBoxData Source #

poke :: Ptr MessageBoxData -> MessageBoxData -> IO () Source #

Show MessageBoxData Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> MessageBoxData -> ShowS Source # show :: MessageBoxData -> String Source # showList :: [MessageBoxData] -> ShowS Source #
Eq MessageBoxData Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: MessageBoxData -> MessageBoxData -> Bool Source # (/=) :: MessageBoxData -> MessageBoxData -> Bool Source #

data Palette Source #

Constructors

Palette |

Fields

- paletteNColors :: !CInt
- paletteColors :: !(Ptr Color)

#### Instances

Instances details

Storable Palette Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Palette -> Int Source #

alignment :: Palette -> Int Source #

peekElemOff :: Ptr Palette -> Int -> IO Palette Source #

pokeElemOff :: Ptr Palette -> Int -> Palette -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Palette Source #

pokeByteOff :: Ptr b -> Int -> Palette -> IO () Source #

peek :: Ptr Palette -> IO Palette Source #

poke :: Ptr Palette -> Palette -> IO () Source #

Show Palette Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Palette -> ShowS Source # show :: Palette -> String Source # showList :: [Palette] -> ShowS Source #
Eq Palette Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Palette -> Palette -> Bool Source # (/=) :: Palette -> Palette -> Bool Source #

data PixelFormat Source #

Constructors

PixelFormat |

Fields

- pixelFormatFormat :: !Word32
- pixelFormatPalette :: !(Ptr Palette)
- pixelFormatBitsPerPixel :: !Word8
- pixelFormatBytesPerPixel :: !Word8
- pixelFormatRMask :: !Word32
- pixelFormatGMask :: !Word32
- pixelFormatBMask :: !Word32
- pixelFormatAMask :: !Word32

#### Instances

Instances details

Storable PixelFormat Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: PixelFormat -> Int Source #

alignment :: PixelFormat -> Int Source #

peekElemOff :: Ptr PixelFormat -> Int -> IO PixelFormat Source #

pokeElemOff :: Ptr PixelFormat -> Int -> PixelFormat -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO PixelFormat Source #

pokeByteOff :: Ptr b -> Int -> PixelFormat -> IO () Source #

peek :: Ptr PixelFormat -> IO PixelFormat Source #

poke :: Ptr PixelFormat -> PixelFormat -> IO () Source #

Show PixelFormat Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> PixelFormat -> ShowS Source # show :: PixelFormat -> String Source # showList :: [PixelFormat] -> ShowS Source #
Eq PixelFormat Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: PixelFormat -> PixelFormat -> Bool Source # (/=) :: PixelFormat -> PixelFormat -> Bool Source #

data Point Source #

Constructors

Point |

Fields

- pointX :: !CInt
- pointY :: !CInt

#### Instances

Instances details

Storable Point Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Point -> Int Source #

alignment :: Point -> Int Source #

peekElemOff :: Ptr Point -> Int -> IO Point Source #

pokeElemOff :: Ptr Point -> Int -> Point -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Point Source #

pokeByteOff :: Ptr b -> Int -> Point -> IO () Source #

peek :: Ptr Point -> IO Point Source #

poke :: Ptr Point -> Point -> IO () Source #

Show Point Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Point -> ShowS Source # show :: Point -> String Source # showList :: [Point] -> ShowS Source #
Eq Point Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Point -> Point -> Bool Source # (/=) :: Point -> Point -> Bool Source #

data Rect Source #

Constructors

Rect |

Fields

- rectX :: !CInt
- rectY :: !CInt
- rectW :: !CInt
- rectH :: !CInt

#### Instances

Instances details

Storable Rect Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Rect -> Int Source #

alignment :: Rect -> Int Source #

peekElemOff :: Ptr Rect -> Int -> IO Rect Source #

pokeElemOff :: Ptr Rect -> Int -> Rect -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Rect Source #

pokeByteOff :: Ptr b -> Int -> Rect -> IO () Source #

peek :: Ptr Rect -> IO Rect Source #

poke :: Ptr Rect -> Rect -> IO () Source #

Show Rect Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Rect -> ShowS Source # show :: Rect -> String Source # showList :: [Rect] -> ShowS Source #
Eq Rect Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Rect -> Rect -> Bool Source # (/=) :: Rect -> Rect -> Bool Source #

data FPoint Source #

Constructors

FPoint |

Fields

- fPointX :: !CFloat
- fPointY :: !CFloat

#### Instances

Instances details

Storable FPoint Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: FPoint -> Int Source #

alignment :: FPoint -> Int Source #

peekElemOff :: Ptr FPoint -> Int -> IO FPoint Source #

pokeElemOff :: Ptr FPoint -> Int -> FPoint -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO FPoint Source #

pokeByteOff :: Ptr b -> Int -> FPoint -> IO () Source #

peek :: Ptr FPoint -> IO FPoint Source #

poke :: Ptr FPoint -> FPoint -> IO () Source #

Show FPoint Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> FPoint -> ShowS Source # show :: FPoint -> String Source # showList :: [FPoint] -> ShowS Source #
Eq FPoint Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: FPoint -> FPoint -> Bool Source # (/=) :: FPoint -> FPoint -> Bool Source #

data FRect Source #

Constructors

FRect |

Fields

- fRectX :: !CFloat
- fRectY :: !CFloat
- fRectW :: !CFloat
- fRectH :: !CFloat

#### Instances

Instances details

Storable FRect Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: FRect -> Int Source #

alignment :: FRect -> Int Source #

peekElemOff :: Ptr FRect -> Int -> IO FRect Source #

pokeElemOff :: Ptr FRect -> Int -> FRect -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO FRect Source #

pokeByteOff :: Ptr b -> Int -> FRect -> IO () Source #

peek :: Ptr FRect -> IO FRect Source #

poke :: Ptr FRect -> FRect -> IO () Source #

Show FRect Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> FRect -> ShowS Source # show :: FRect -> String Source # showList :: [FRect] -> ShowS Source #
Eq FRect Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: FRect -> FRect -> Bool Source # (/=) :: FRect -> FRect -> Bool Source #

data Vertex Source #

Constructors

Vertex |

Fields

- vertexPosition :: !FPoint
- vertexColor :: !Color
- vertexTexCoord :: !FPoint

#### Instances

Instances details

Storable Vertex Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Vertex -> Int Source #

alignment :: Vertex -> Int Source #

peekElemOff :: Ptr Vertex -> Int -> IO Vertex Source #

pokeElemOff :: Ptr Vertex -> Int -> Vertex -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Vertex Source #

pokeByteOff :: Ptr b -> Int -> Vertex -> IO () Source #

peek :: Ptr Vertex -> IO Vertex Source #

poke :: Ptr Vertex -> Vertex -> IO () Source #

Show Vertex Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Vertex -> ShowS Source # show :: Vertex -> String Source # showList :: [Vertex] -> ShowS Source #
Eq Vertex Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Vertex -> Vertex -> Bool Source # (/=) :: Vertex -> Vertex -> Bool Source #

data RendererInfo Source #

Constructors

RendererInfo |

Fields

- rendererInfoName :: !CString
- rendererInfoFlags :: !Word32
- rendererInfoNumTextureFormats :: !Word32
- rendererInfoTextureFormats :: ![Word32]
- rendererInfoMaxTextureWidth :: !CInt
- rendererInfoMaxTextureHeight :: !CInt

#### Instances

Instances details

Storable RendererInfo Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: RendererInfo -> Int Source #

alignment :: RendererInfo -> Int Source #

peekElemOff :: Ptr RendererInfo -> Int -> IO RendererInfo Source #

pokeElemOff :: Ptr RendererInfo -> Int -> RendererInfo -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO RendererInfo Source #

pokeByteOff :: Ptr b -> Int -> RendererInfo -> IO () Source #

peek :: Ptr RendererInfo -> IO RendererInfo Source #

poke :: Ptr RendererInfo -> RendererInfo -> IO () Source #

Show RendererInfo Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> RendererInfo -> ShowS Source # show :: RendererInfo -> String Source # showList :: [RendererInfo] -> ShowS Source #
Eq RendererInfo Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: RendererInfo -> RendererInfo -> Bool Source # (/=) :: RendererInfo -> RendererInfo -> Bool Source #

data RWops Source #

Constructors

RWops |

Fields

- rwopsSize :: !(FunPtr (Ptr RWops -> IO Int64))
- rwopsSeek :: !(FunPtr (Ptr RWops -> Int64 -> CInt -> IO Int64))
- rwopsRead :: !(FunPtr (Ptr RWops -> Ptr () -> CSize -> CSize -> IO CSize))
- rwopsWrite :: !(FunPtr (Ptr RWops -> Ptr () -> CSize -> CSize -> IO CSize))
- rwopsClose :: !(FunPtr (Ptr RWops -> IO CInt))
- rwopsType :: !Word32

#### Instances

Instances details

Storable RWops Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: RWops -> Int Source #

alignment :: RWops -> Int Source #

peekElemOff :: Ptr RWops -> Int -> IO RWops Source #

pokeElemOff :: Ptr RWops -> Int -> RWops -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO RWops Source #

pokeByteOff :: Ptr b -> Int -> RWops -> IO () Source #

peek :: Ptr RWops -> IO RWops Source #

poke :: Ptr RWops -> RWops -> IO () Source #

Show RWops Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> RWops -> ShowS Source # show :: RWops -> String Source # showList :: [RWops] -> ShowS Source #
Eq RWops Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: RWops -> RWops -> Bool Source # (/=) :: RWops -> RWops -> Bool Source #

data Surface Source #

Constructors

Surface |

Fields

- surfaceFormat :: !(Ptr PixelFormat)
- surfaceW :: !CInt
- surfaceH :: !CInt
- surfacePixels :: !(Ptr ())
- surfaceUserdata :: !(Ptr ())
- surfaceClipRect :: !Rect
- surfaceRefcount :: !CInt

#### Instances

Instances details

Storable Surface Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Surface -> Int Source #

alignment :: Surface -> Int Source #

peekElemOff :: Ptr Surface -> Int -> IO Surface Source #

pokeElemOff :: Ptr Surface -> Int -> Surface -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Surface Source #

pokeByteOff :: Ptr b -> Int -> Surface -> IO () Source #

peek :: Ptr Surface -> IO Surface Source #

poke :: Ptr Surface -> Surface -> IO () Source #

Show Surface Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Surface -> ShowS Source # show :: Surface -> String Source # showList :: [Surface] -> ShowS Source #
Eq Surface Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Surface -> Surface -> Bool Source # (/=) :: Surface -> Surface -> Bool Source #

data Version Source #

Constructors

Version |

Fields

- versionMajor :: !Word8
- versionMinor :: !Word8
- versionPatch :: !Word8

#### Instances

Instances details

Storable Version Source # |

Instance details

Defined in SDL.Raw.Types

Methods

sizeOf :: Version -> Int Source #

alignment :: Version -> Int Source #

peekElemOff :: Ptr Version -> Int -> IO Version Source #

pokeElemOff :: Ptr Version -> Int -> Version -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Version Source #

pokeByteOff :: Ptr b -> Int -> Version -> IO () Source #

peek :: Ptr Version -> IO Version Source #

poke :: Ptr Version -> Version -> IO () Source #

Show Version Source # |
Instance details Defined in SDL.Raw.Types Methods showsPrec :: Int -> Version -> ShowS Source # show :: Version -> String Source # showList :: [Version] -> ShowS Source #
Eq Version Source # |
Instance details Defined in SDL.Raw.Types Methods (==) :: Version -> Version -> Bool Source # (/=) :: Version -> Version -> Bool Source #